#!/usr/bin/env python

import os, sys, base64

VERSIONEER_b64 = """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"""
newver = "0.20"


def main():
    if len(sys.argv) < 2:
        print("Usage: versioneer install")
        sys.exit(1)

    command = sys.argv[1]
    if command in ("version", "--version"):
        print("versioneer (installer) %s" % newver)
        sys.exit(0)

    if command != "install":
        print("Usage: versioneer install")
        sys.exit(1)

    v = base64.b64decode(VERSIONEER_b64.encode('ASCII'))
    if os.path.exists("versioneer.py"):
        for line in open("versioneer.py").readlines()[:5]:
            if line.startswith("# Version: "):
                oldver = line[len("# Version: "):].strip()
                if oldver != newver:
                    print("replacing old versioneer.py (%s)" % oldver)
                break
        else:
            print("overwriting existing versioneer.py")
    with open("versioneer.py", "wb") as f:
        f.write(v)
    print("versioneer.py (%s) installed into local tree" % newver)
    print("Now running 'versioneer.py setup' to install the generated files..")
    if " " in sys.executable:
        import subprocess  # Do not import unless absolutely necessary to avoid compatibility issues
        subprocess.call([sys.executable, "versioneer.py", "setup"])
    else:
        os.execl(sys.executable, sys.executable, "versioneer.py", "setup")

if __name__ == '__main__':
    main()
